Twosteps <-
function(mydata0, epsilon){
	mydata0=mydata0[order(mydata0$seq),]
	seq <-mydata0$seq
	ID <-mydata0$ID
	old.value <-mydata0$match
	old.L <- mydata0$length

	K<-length(unique(ID))   
	m<-length(unique(seq)) 
	row.info<-as.numeric(factor(seq,levels=sort(unique(seq)), labels=1:m))
	col.info<-as.numeric(factor(ID,levels=sort(unique(ID)), labels=1:K))

	Begin <- which((row.info-c(0,row.info[-length(row.info)]))!=0)
	End <- which((row.info-c(row.info[-1],0))!=0) 
	ID.map=cbind(1:K,sort(unique(ID))) 
	cumul.row<-table(row.info) 

 	R.Old <- c(0.9, rep((1-0.9)/(K-1), K-1))   
 	R.New <- rep(1/K, K)                        
 	p.Old <- 0.1
 	p.New <- 0.05
 	ID.indicator<-split(sort(col.info,index=TRUE)$ix,sort(col.info))

	min.value <- rep(sapply(1:m, function(i) {min(old.value[Begin[i]:End[i]])}), cumul.row)
	value <- old.value - min.value + 1
	L <- old.L-min.value+1

 while(max(abs(R.Old-R.New)) > 0.0001 || abs(p.Old-p.New) > 0.0001)
 {
  R.Old <- R.New
  p.Old <- p.New
  R.vec <- R.Old[col.info]
  T <- R.vec*(1-p.Old)^value*p.Old^(L-value)
  T.Den <- rep(sapply(1:m, function(i) {sum(T[Begin[i]:End[i]])}), cumul.row)
  T <- T/T.Den
  R.New <- sapply(1:K, function(i) {sum(T[ID.indicator[[i]]])})/m  
  p.New <- 1-sum(old.value*T)/sum(old.L*T)
 }

####################
	misrange <- t(sapply(1:m, function(i){cbind(max(mydata0$match[Begin[i]:End[i]]),mismatch(max(mydata0$length[Begin[i]:End[i]]), 	max(mydata0$match[Begin[i]:End[i]]),p.New, epsilon))}))
	Find.Pos<-sapply(1:m, function(i) {which(mydata0$match[Begin[i]:End[i]]>=(misrange[i,1]-misrange[i,2]))})
 	Assignment <- unlist(sapply(1:m, function(i) {Begin[i]-1+Find.Pos[[i]]}))
 	gowhere = mydata0[Assignment,]
 
 	ns=length(unique(gowhere$seq))
 	
	func=data.frame(table(gowhere$FunctionRole)/ns)	
	names(func)=c("name", "value")		
	func$name=as.character(func$name)

	s3=data.frame(table(gowhere$sub3)/ns)
	names(s3)=c("name", "value")		
	s3$name=as.character(s3$name)

	s2=data.frame(table(gowhere$sub2)/ns)
	names(s2)=c("name", "value")		
	s2$name=as.character(s2$name)

	s1=data.frame(table(gowhere$sub1)/ns)
	names(s1)=c("name", "value")		
	s1$name=as.character(s1$name)

	return(list(s1=s1,s2=s2,s3=s3, func=func))
}
