bootstrap <-
function(original, boot.n, epsilon, method){
	est=Twosteps(original, epsilon)
	ss1=est$s1
	ss2=est$s2
	ss3=est$s3
	ssf=est$func	

	uniseq<-unique(original$seq)
	for(i in 1:boot.n){
 		cat(" i ==", i,  "   ", format(Sys.time(), "%a %b %d %X %Y"), "\n")

		ss.seq<-sample(uniseq,length(uniseq),replace=TRUE)
		ss.data<-subset(original,seq%in%ss.seq)
		ss.count<-data.frame(table(ss.seq))
		merge.ss<-merge(ss.data,ss.count,by.x="seq",by.y="ss.seq")
		rep.ssdata<-rep(merge.ss[,-(ncol(merge.ss))],times=merge.ss$Freq)
		new.seq<-paste(rep.ssdata$seq,"~",rep.ssdata$ID,":",sep="")
		rep.seq<-factor(new.seq,levels=unique(new.seq))
		seq.table<-unclass(table(rep.seq))
		newseq.tmp<-sapply(seq.table,function(s){1:s})
		newseq.tmp<-unlist(newseq.tmp)
		newseq<-paste(rep.seq,newseq.tmp,sep=".")

		new.seq<-paste(substring(newseq,1,regexpr("~",newseq)-1),substring(newseq,regexpr(":",newseq)+1,10000),sep="")

		new.data<-data.frame(seq=new.seq,rep.ssdata[,-1])
		boot=Twosteps(new.data, epsilon) 	
		names(boot$s1)=c("name", paste("value", i, sep="."))
		names(boot$s2)=c("name", paste("value", i, sep="."))
		names(boot$s3)=c("name", paste("value", i, sep="."))
		names(boot$func)=c("name", paste("value", i, sep="."))

		ss1=merge(ss1,boot$s1, by="name", all.x=TRUE)
		ss2=merge(ss2,boot$s2, by="name", all.x=TRUE)
		ss3=merge(ss3,boot$s3, by="name", all.x=TRUE) 	
		ssf=merge(ssf,boot$func, by="name", all.x=TRUE) 	
	 }
	 
	if(method=="B"){ 
	Function=LowHigh.B(est$func, ssf)
	sub3=LowHigh.B(est$s3, ss3)
	sub2=LowHigh.B(est$s2, ss2)
	sub1=LowHigh.B(est$s1, ss1)
	}
	
	if(method=="NP"){ 
	Function=LowHigh.NP(est$func, ssf)
	sub3=LowHigh.NP(est$s3, ss3)
	sub2=LowHigh.NP(est$s2, ss2)
	sub1=LowHigh.NP(est$s1, ss1)
	}	
	return(list(Function=Function, sub1=sub1, sub2=sub2, sub3=sub3))
}
